<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
<?xbl href="bindings.xml"?>
<html><head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><title>X-Smiles.org</title>

<link href="xsmiles_style.css" type="text/css" rel="stylesheet">
<link href="xsmiles_style.html" type="text/css" rel="stylesheet">
<style type="text/css">
					td.nav, table.nav, tr.nav,td.contentarea {vertical-align: top; border-width:0px;}
				</style><!--NOTE: THIS FILE IS AUTOMATICALLY GENERATED BY XSL, DO NOT EDIT BY HAND. EDIT FEATURES.XML INSTEAD AND RUN 'build.sh sitedoc--></head><body>
<img alt="X-SMILES.ORG" src="xsmiles.gif"><table class="nav">
<tbody><tr class="nav">
<td class="nav" style="vertical-align: top; width: 100pt;">
 <div id="navbar" class="navbar">
     <div>
     <p id="link-xsmiles" class="link">
      <a class="linkmain" href="index.html">X-Smiles</a>
     </p>
     <p id="link-objectives" class="link">
      <a class="linkmain" href="xsmiles_objectives.html">Objectives</a>
     </p>
     <p id="link-contributors" class="link">
      <a class="linkmain"  href="contributors.html">Contributors</a>
     </p>
     <p id="link-screenshots" class="link">
      <a class="linkmain" href="screenshots.html">Screenshots</a>
     </p>
     <p id="link-downloads" class="link">
      <a class="linkmain" href="download.html">Download</a>
     </p>
     <p id="link-documents" class="link">  
      <a class="linkmain">Documents</a>
      <a class="linksub1" href="xsmiles_features.html">Features</a> 
      <a class="linksub1" href="xsmiles_installation.html">Installation</a>
      <a class="linksub1" href="platforms.html">Platforms</a>
      <a class="linksub1" href="xsmiles_faq.html">FAQ</a>
      <a class="linksub1" href="xsmiles_test.html">Testimonials</a>
     </p>
     <p id="link-developers" class="link">
      <a class="linkmain">Developer Area</a>
      <a class="linksub1" href="participate.html">Participating</a>
      <a class="linksub1" href="techspec.html">Technical Spec</a>
      <a class="linksub1" href="xsmiles_compiling.html">How to compile</a>
      <a class="linksub1" href="xsmiles_future.html">Projects</a>
      <a class="linksub1" href="http://www.xsmiles.org/javadoc/index.html">Javadoc</a>
      <a class="linksub1" href="http://www.xsmiles.org/cvs.html">CVS access</a>
      <a class="linksub1" href="xsmiles_smil.html">SMIL package</a>
      <a class="linksub1" href="http://www.xsmiles.org/demo/demos.xhtml">Demos</a>
     </p>
     <p id="link-reading" class="link">
      <a class="linkmain">Reading</a>
      <a class="linksub1" href="presentations.html">Presentations</a>
      <a class="linksub1" href="publications.html">Publications</a>
     </p>
     <p id="link-feedback" class="link">
      <a class="linkmain">Feedback</a>
      <a class="linksub1" href="http://sourceforge.net/bugs/?group_id=18700"> Bugs</a>
      <a class="linksub1" href="xsmiles_lists.html">Mailing lists</a>
     </p>
    </div>
    </div>
</td><td class="contentarea">
<div class="contentarea">
<h1>Participating in the development</h1>
<h2>General</h2>
<p>X-Smiles is an non-profit open-source project with a <a href="http://www.xsmiles.org/licenses/LICENCE_XSMILES">license</a> similar to the Apache licence. Everybody is encouraged to participate in the development.</p>
<p>This document describes the details on how to create and submit
patches, and which kind of coding style should you use when creating
code for the project.<br>
</p>
<h2>Coding style</h2>All developers should follow the coding style defined in <a href="http://www.xsmiles.org/coding_style.html">this document</a>. <br> 
<span style="font-weight: bold;">Use 4 spaces instead of tabs</span>!<br> 
<h2>Creating and applying patches</h2>
<p>First, make sure you are making changes in the most recent version
of the sources - for this, it is best to use CVS to check out the
source (usually on the CVS trunk; sometimes the most active release
branch - ask if unsure), make your modifications (but do not check them
in), and then run (example for Unix, other operating systems similar):</p>
<br>
<div class="code">
<code>$ cd&nbsp;/source/xsmiles<br>$ ls<br>
<font class="comment">shows...</font>
<br>$ cvs&nbsp;update src <font class="comment">...or wherever&nbsp;your changes&nbsp;are;&nbsp;may&nbsp;be&nbsp;&gt;1 module</font>
<br>
<font class="comment">make&nbsp;sure you&nbsp;are working against current&nbsp;sources</font>
<br>$ cvs&nbsp;diff src<br>
<font class="comment">sanity-check the&nbsp;change</font>
<br>$ cvs&nbsp;-f diff&nbsp;-u -N src &gt;&nbsp;/tmp/my-patch.diff<br>
<font class="comment">sanity-check the&nbsp;patch<br>
</font></code>
</div>
<br>
<p>If you are adding or modifying binary files, it is best to attach
the new or modified binary files separately and exclude them from the
textual patch.</p>
<p>Common patch mistakes include:</p>
<ol>
<li>
<p>Forgetting <code>-u</code>. Default-format diffs show no context and will be <em>hard to read and apply</em>, especially if they were made against somewhat out-of-date sources. <code>-c</code> is also OK but <code>-u</code> is most common.</p>
</li>
<li>
<p>Forgetting about new (added) files. Run <code>cvs&nbsp;add</code> (but do not commit!) to make sure CVS thinks of them as added as part of the patch, and remember <code>-N</code> which includes them in the patch. Also run <code>cvs&nbsp;remove</code> (but do not commit) when a patch should delete some files.</p>
</li>
<li>
<p>Using other switches such as <code>-t</code> which can make the patch difficult to apply.</p>
</li>
<li>
<p>Starting from the wrong directory. <em>Always</em> make patches from the root of the source tree to avoid confusion.</p>
</li>
<li>
<p>Manually editing patches. You may be tempted to concatenate patches,
or manually edit them to exclude things you do not really want to
submit. <em>Do not do this.</em> The patch may be corrupted as a
result. Fix your sources to reflect what you want the result to be, and
run a fresh diff. Include all affected files in the diff command, even
if they are in different modules.</p>
</li>
<li>
<p>Including extraneous changes. Look over your patch to make sure
every change relates to the fix you are making, and is necessary.
Remember other people will read your patch before applying it! Do not
make gratuitous whitespace changes. Do not reformat existing code you
are not modifying.</p>
</li>
<li>
<p>Using the plain diff command. Use <code>cvs&nbsp;diff</code> to ensure that exact information about repository path and original version of the patched files is retained.</p>
</li>
<li>
<p>Using old sources. Patches made against obsolete sources may be hard
to use. Make sure you are using recent versions of all source file (<code>cvs&nbsp;update</code>
first). If you must submit several patches against the same files, be
sure to indicate if they must be applied in some particular order.</p>
</li>
</ol>
<p>A properly made patch is easy to apply by someone with commit access who has reviewed it. Use of the Unix <code>patch</code> tool is recommended; Windows users should be able to get it from the Cygwin tools distribution.</p>
<br>
<div class="code">
<code><font class="comment">save&nbsp;patch to&nbsp;disk,&nbsp;say /tmp/suggested-patch.diff</font>
<br>$ cd&nbsp;/sources/netbeans/nb_all<br>$&nbsp;patch -p0 --dry-run&nbsp;&lt;&nbsp;/tmp/suggested-patch.diff<br>
<font class="comment">make&nbsp;sure&nbsp;no errors&nbsp;are reported -&nbsp;this&nbsp;just tests&nbsp;the&nbsp;patch format</font>
<br>$&nbsp;patch -p0&nbsp;&lt;&nbsp;/tmp/suggested-patch.diff<br>$ cvs&nbsp;diff&nbsp;beans/ <font class="comment">or whatever&nbsp;part of&nbsp;sources&nbsp;are affected</font>
<br>
<font class="comment">sanity-check diff,&nbsp;compare to&nbsp;patch (should&nbsp;be&nbsp;same or&nbsp;similar)</font>
<br>
<font class="comment">test, do&nbsp;a&nbsp;build, commit&nbsp;as&nbsp;usual</font>
<br>
</code>
</div>
<p>If the "dry run" fails, you may need to use additional options to <code>patch</code>,
or at worst just apply the patch manually. Do not forget to
sanity-check file additions and removals! You probably need to use <code>cvs&nbsp;add</code> and <code>cvs&nbsp;remove</code> to complete these.</p>
<h2>Making patches available</h2>
<p>The preferred way to make a patch available is to send it to the
developers@xsmiles.org mailing list. The instructions on how to
subscribe can be found <a href="http://www.xsmiles.org/xsmiles_lists.html">here</a>.<br>
<br>
</p>
<p>Another way is to include the patch as an attachment in a bug report in the <a href="http://sourceforge.net/bugs/?group_id=18700">bug area</a>.<br>
</p>
<h2>CVS Access<br>
</h2>The CVS access is desribed in the <a href="http://www.xsmiles.org/cvs.html">CVS page</a>.<br>
<hr>
		  Copyright (c) 2000-2007 X-Smiles.org et.al.
	</div>
</td>
</tr>
</tbody></table>
</body></html>